package moka;
import robocode.*;
import java.awt.Color;


/**
 * MokaEnhanced - a robot by (your name here)
 */
public class MokaEnhanced extends Robot
{
	// Costante PI greco
	static final double PI = Math.PI;
	
	// Variabili usate per salvare la posizione del nemico
	double enemyPosX;
	double enemyPosY;
	double enemyBearing;
	

		
	/**
	 * run: MokaEnhanced's default behavior
	 */
	public void run() {
		
		//Imposto il colore
		setColors(Color.red,Color.blue,Color.green);
		//Faccio una prima scansione del campo
		turnRadarRight(360);
		//Rendo indipendenti radar e torretta dalla base
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
		while(true) {
			ahead(200);
			turnRadarRight(360);
		}
	}

	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		//Calcolo la posizone del nemico
		calculatePosition(e.getDistance(),e.getBearingRadians());
		//Calcolo di quanto spostare la torretta per mirare al nemico
		double dest=Math.toDegrees(normaliseBearing(Math.toRadians(getGunHeading())-enemyBearing));
		//Stampo delle variabili per il debug
		out.println(Math.toDegrees(enemyBearing));
		out.println(getGunHeading());
		out.println(dest);
		//Giro torretta
		turnGunLeft(dest);
		//Saparo
		fire(2);
	}

	/**
	 * onHitByBullet: What to do when you're hit by a bullet
	 */
	public void onHitByBullet(HitByBulletEvent e) {
		turnRight(90-e.getBearing());
	}

	/**
	 * onHitByBullet: What to do when you're hit by a bullet
	 */
	public void onHitWall(HitWallEvent e) {
		turnRight(120 - e.getBearing());
	}

	/**
	 * onHitRobot: What to do when you hit a robot
	 */	
	public void onHitRobot(HitRobotEvent e) {
		back(100);
		turnRight(90 - e.getBearing());
	}
	
	/**
	 * Calcolo la posizone assoluta del robot
	 */
	public void calculatePosition(double distance, double bearing) {
		enemyBearing=bearing+Math.toRadians(getHeading());
	}

		
	/**
	 * Mi assicuro che l'angolo sia tra -180 e 180
	 */	
	public static double normaliseBearing(double ang) {
		if (ang > PI)
			ang -= 2*PI;
		if (ang < -PI)
			ang += 2*PI;
		return ang;
	}
	
}
